*  Program Ŀ
*   Application: Demo of FiveWin and SilverWare Windows Communications      
*   Description: Download FiveWin Demos. Written w/ FiveWin & SWCT          
*     File Name: FIVEDEMO.PRG                                               
*        Author: John H. Stolte, Sr.  & Neil Freeman                        
*  Date created: 03-04-95              Date updated: 03-04-95              
*  Time created: 04:03:04pm            Time updated: 04:03:04pm            
*     Make File: Bld.bat                                                    
*     Exec File: FiveDemo.Exe                                               
*     Copyright: (c) 1995 by Omicron Software Publishing Corp.              
* 

#include "FIVEWIN.CH"
#INCLUDE "SWCTDEF.CH"

STATIC oWnd, hSWCTLIB, hBorland
STATIC oBitMap1, oBitmap2, oBitmap3
STATIC oItem1,oItem2

FUNCTION TALK()
   Local hBorland,hSWCTLIB,oIcon,oBar

   hBorland := LoadLibrary("BWCC.DLL")
   hSWCTLIB := LoadLibrary("SWCT500.DLL")

   SET 3DLOOK ON

   DEFINE ICON oIcon RESOURCE "FIVEWIN"

   DEFINE WINDOW oWnd FROM 0, 0 TO 24, 80 TITLE "FiveWin/SilverWare Demo" ;
      COLOR CLR_WHITE, CLR_BLUE MENU BuildMenu() ;
      ICON oIcon

   SET MESSAGE OF oWnd TO "Get The FiveWin Evaluation Edition Using FiveWin and SilverWare" CENTERED

   // Create a Tool bar and add some buttons //
   // You will notice that we are using disk files for the bitmaps, but you
   // can just as easily use bitmaps in an .rc file or .DLL.

   DEFINE BUTTONBAR oBar OF oWnd

   DEFINE BUTTON oBtnQuit FILE "QUIT.BMP" OF oBar MESSAGE "Exit FiveDemo" ;
      ACTION If(MsgYesNo("Are You Sure You Want To Quit?"),oWnd:End(),)

   DEFINE BUTTON oBtnDial FILE "Dial.bmp" OF oBar MESSAGE "Automatic Download Of The FiveWin Demo"  ;
      ACTION (oBtnQuit:Disable(),oBtnDial:Disable(),oItem1:Disable(),oItem2:Disable(),DownFive())

   DEFINE BUTTON oBtnSource FILE "EDIT.BMP" OF oBar MESSAGE "View Source Code" ;
      ACTION Winexec("NOTEPAD.EXE FIVEDEMO.PRG")

   DEFINE BUTTON oBtnDist FILE "LIST.BMP" OF oBar MESSAGE "Where To Buy FiveWin" ;
      ACTION Winexec("NOTEPAD.EXE Dist.txt")

   ACTIVATE WINDOW oWnd ON INIT ( DoBitMaps(), ;
      Winexec("Write.exe Start.wri") ) MAXIMIZED

   FreeLibrary(hSWCTLIB)
   FreeLibrary(hBorland)
   SET 3DLOOK OFF

RETURN NIL

// Notice in the MenuItem declarations that two of them have different syntax
// than the others.  The reason for this, is that later in the program we will
// want to disable certain menu options.  In order to do this, we need an
// OBJECT to manipulate (oItem1 & oItem2)  The remainder of the menu options
// won't require manipulation, so don't necessarily require and object being
// declared.  It is optional, and can be done for consistancy sake if you wish.
FUNCTION BuildMenu()

   MENU mainMenu
      MENUITEM "&Files"
      MENU
         MENUITEM oItem1 PROMPT "&Download FiveWin Evaluation" Action ( DownFive() ) MESSAGE "Automatic Download Of The FiveWin Demo"
         MENUITEM "View &ReadMe" ACTION ( Winexec("Write.exe Start.wri"))
         MENUITEM "View &Source Code" ACTION ( Winexec("NotePad.exe FiveDemo.prg"))
         MENUITEM "Where To &Buy FiveWin" ACTION ( Winexec("NotePad.exe Dist.txt"))
      SEPARATOR
         MENUITEM oItem2 PROMPT "e&Xit" Action ( oWnd:End() )
      ENDMENU

      MENUITEM "&About" MESSAGE "About This Demo"
      MENU
         MENUITEM "About &FiveWin" Action ( AFiveWin() ) MESSAGE "About The FiveWin Clipper Library"
         MENUITEM "About &SilverWare" Action ( ASilver() ) MESSAGE "About SilverWare Communications"
      ENDMENU

   ENDMENU

RETURN mainMenu

FUNCTION DownFive()

   LOCAL nReturn := 0                            // SWCT return values
   LOCAL x := 0
   LOCAL PortId := 0                             // COM Port ID for SWCT
   LOCAL SndStr := ""                            // Send String
   LOCAL RcvStr := ""                            // Receive String
   LOCAL ConStr := ""                            // Parsed Connect String
   LOCAL ZmdStr := "**"+CHR(24)+"B00"            // ZMODEM Receive Start String
   LOCAL ConnectStr := SPACE(40)                 // SWCT Connect String
   LOCAL LenConStrLong := 0                      // SWCT Length of Connect String
   Local PBX           := "      "
   LOCAL LongDist      := "1     "
   LOCAL AreaCode      := "804"
   LOCAL BBSNumber     := "375-9639"
   Local DialString    := ""
   Local ModemSetup    := "ATZ &C1 &D2"
   Local EndTime       := 0
   local mycount       := 1                      // debug code

   SET MESSAGE OF oWnd TO "Initializing Modem" CENTERED
   PortId := SWCDlgOpen(oWnd:hWnd,"",0)          // Open The COMPort

   if PortId < 0
      MsgStop("Couldn't Open ComPort - Please Shut Down Windows and Try Again","Error On ComPort")
      RETURN NIL
   endif

   SWCSetBaud(PortId, 19200)                     //  Pre-Set the Port
                                                 //  Parameters the way we
   SWCSetPari(PortId, 0)                         //  think they should be
   SWCSetRTSC(PortId, 1)                         //  for best performance
   SWCSetStop(PortId, 1)
   SWCSetWord(PortId, 8)
   SWCZMSetRe(PortId, 1)                         // Set Zmodem Auto Resume ON
   SWCXYZMSCD(PortID, 1)                         // Monitor carrier Detect during transfer

   SET MESSAGE OF oWnd TO "Set Your Modem Options" CENTERED

   SWCDlgGetU(oWnd:hWnd,"",PortID)               // Show the user the settings
                                                 // and let them change them
                                                 // if they want/need to

   IF PortID <> -462                             // can't open - so bye-bye
      SWCSMRese(PortId)                          // send a modem reset

      // we need to deal with dialing 1 804 or 9,, for pbx etc.
      // depending on where they are calling from

      SET MESSAGE OF oWnd TO "Set A Modem Init String" CENTERED
      MsgGet("Modem Setup String?", ;
         "Modem String (Click OK for default):", @ModemSetup)

      SET MESSAGE OF oWnd TO "Do You Need any PBX Codes To Be Dialed?" CENTERED
      MsgGet("What PBX Codes Do You Need? (If Any)", ;
         "PBX Codes (ie: 9,,):", @PBX)

      SET MESSAGE OF oWnd TO "Probably Have to Dial a 1" CENTERED
      MsgGet("What LD  Code Do You Need? (If Any)", ;
         "Long Dist Codes (ie: 1 or 011):", @LongDist)

      SET MESSAGE OF oWnd TO "If You're Not In Cartersville, You'll Probabaly Need This" CENTERED
      MsgGet("The Area Code", "Area Code:", @AreaCode)

      DialString := alltrim(PBX)+alltrim(LongDist)+ ;
         alltrim(AreaCode)+alltrim(BBSNumber)

      SET MESSAGE OF oWnd TO "Sending The Modem Initialization String to the Modem" CENTERED
      SWCSMTrans(PortId, alltrim(ModemSetup))    // Send modem setup string
      SWTWai(2000)
      SWCFlushRe(PortId)

      SET MESSAGE OF oWnd TO "Going to The Auto Dialer" CENTERED
      nReturn := SWCDLGAuto( oWnd:hWnd,"",PortId,0,DialString, ;
         ConnectStr,LenConStrLong,75,5 )

      IF nReturn = 0

         DO WHILE SWCGetCarr(PortId) == 1        // TRUE

            ConStr := UPPER(ConnectStr)          // Remove unwanted garbage
            ConStr := STRTRAN(ConStr,"CONNECT","") // from the connect string
            ConStr := STRTRAN(ConStr,"TO","")    // leaving only the connect
            ConStr := STRTRAN(ConStr,"AT","")    // message baudrate
            ConStr := STRTRAN(ConStr,"BAUD","")
            ConStr := STRTRAN(ConStr,"RATE","")
            ConStr := STRTRAN(ConStr,"WITH","")
            ConStr := STRTRAN(ConStr," ","")

            IF VAL(ConStr) >= 9600               // MUST be 9600 or greater

               SET MESSAGE OF oWnd TO "Got A Connection!" CENTERED

               CursorWait()

               oBitMap1:Show()

               SET MESSAGE OF oWnd TO "Sending The Log On Strings" CENTERED
               SndStr := "n q ns"+chr(13)        // answer and skip the
               SWCTXStrin(PortId, SndStr)        // opening screens

               SWTWai(5000)                      // give it a little time....

               SWCFlushRe(PortId)
               SndStr := cFirst cLast cPass     // Send the log-on
               SWCTXStrin(PortId, SndStr)

               SndStr := "N"+chr(13)             // no, we don't want
               SWCTXStrin(PortId, SndStr)        // to check for mail

               SndStr := chr(13)
               SWCTXStrin(PortId, SndStr)

               SWTWai(2000)                      // give it a little time....

               oBitMap1:End()
               oBitMap2:Show()

               SET MESSAGE OF oWnd TO "Preparing The Download...  Please Wait..." CENTERED
               SndStr := "FIVEDEMO"              // run the PPE program
               SWCTXStrin(PortId, SndStr)        // (command) to flag the

               SndStr := chr(13)                 // files for download
               SWCTXStrin(PortId, SndStr)

               SWTWai(2000)                      // give it a little time....

               SndStr := "Y"+CHR(13)             // answer yes to the
               SWCTXStrin(PortId, SndStr)        //"are you sure question"

               SWTWai(2000)                      // give it a little time....

               SndStr := chr(13)                 // one more for good measure
               SWCTXStrin(PortId, SndStr)

               RcvStr := ""
               SWCFlushRe(PortId)

               EndTime := 60 + seconds()

               DO WHILE .T.                      // Check for messages

                  IF EndTime < Seconds()         // Timer check
                     CursorArro()
                     ? "Timed Out Waiting For ZMODEM Start Up."
                     CursorWait()
                     x := -492
                     EXIT

                  ENDIF
                  IF SWCRxQEmpt(PortId) = 0

                     SET MESSAGE OF oWnd TO "Here Come Your Files" CENTERED

                     CursorWait()
                     RcvStr := RcvStr + CHR(SWCRxChara(PortId))

                     IF AT(ZmdStr,RcvStr) > 0    // We have lift off

                        SET MESSAGE OF oWnd TO "Downloading The FiveWin Demo Files" CENTERED

                        x := SWCRZMOD(PortId,".\",oWnd:hWnd) // get the files
                        DO CASE
                           Case x == -492
                              MsgStop("Transfer Aborted - Timed Out", "Aborted")
                           Case x == -491
                              MsgStop("Transfer Aborted - Abort", "Aborted")
                           Case x == -489
                              MsgStop("Transfer Aborted - No Carrier", "Aborted")
                           Case x == -488
                              MsgStop("Transfer Aborted - Can't Open File", "Aborted")
                           Case x == -487
                              MsgStop("Transfer Aborted - Bad Block Check", "Aborted")
                           Case x == -485
                              MsgStop("Transfer Aborted - Local Abort", "Aborted")
                           Case x == -484
                              MsgStop("Transfer Aborted - Remote Abort", "Aborted")
                           Case x == -483
                              MsgStop("Transfer Aborted - Bad Block Number", "Aborted")
                           Case x == -482
                              MsgStop("Transfer Aborted - Block Frame Error", "Aborted")
                           Case x == -467
                              MsgStop("Transfer Aborted - Bad Hex Digit", "Aborted")
                           Case x == -466
                              MsgStop("Transfer Aborted - Bad Escape", "Aborted")
                           Case x == -465
                              MsgStop("Transfer Aborted - Garbled Packet", "Aborted")
                        ENDCASE

                        SndStr := chr(13)        // to make sure that we're
                        SWCTXStrin(PortId, SndStr) // at the main menu
                        //                      CursorArro()
                     ENDIF

                     // In Case of  The "Event"...
                     // Everyday at 14:00 EST time, or BBS runs it's daily Maintenance
                     // "Event"  If you call in to close to that, you will be denied
                     // the ability to download.  Call Back after about 14:15 EST

                     IF AT("INSUFFICIENT TIME", UPPER(RcvStr)) > 0
                        CursorArro()
                        ? "Sorry, Our Event is About to run.  Try again later."
                        CursorWait()
                        EXIT
                     ENDIF

                     IF AT("ABORTED", UPPER(RcvStr)) > 0
                        CursorArro()
                        ? "Transfer Aborted"
                        CursorWait()
                        EXIT
                     ENDIF

                     IF x < 0                    // File transfer failed 1 exit
                        EXIT

                     ENDIF

                  ENDIF

               ENDDO

               IF x < 0                          // File transfer failed 2 exit
                  EXIT

               ENDIF


               SET MESSAGE OF oWnd TO "Logging Off The BBS...  Please Wait..." CENTERED
               CursorWait()
               SWTWai(1000)                      // give it a little time....

               SWCFlushRe(PortId)
               SndStr := chr(13)                 // to make sure that we're
               SWCTXStrin(PortId, SndStr)        // at the main menu


               SndStr := chr(13)+Chr(13)         // extra insurance
               SWCTXStrin(PortId, SndStr)

               SWTWai(3000)                      // give it a little time....

               SndStr := "G"+chr(13)             // say "Good night Gracie"
               SWCTXStrin(PortId, SndStr)

               SWTWai(1000)                      // give it a little time....

               SndStr := "Y"+chr(13)             // say Yes to
               SWCTXStrin(PortId, SndStr)        // "Proceed with logoff"


               SndStr := chr(13)                 // extra insurance
               SWCTXStrin(PortId, SndStr)

            ELSE

               Cursorarro()
               ? "Sorry, you must dial in at 9600 baud or Higher"
               CursorWait()
               EXIT

            ENDIF
         ENDDO
      ENDIF


      oBitmap2:End()
      oBitMap3:Show()

   ENDIF

   SET MESSAGE OF oWnd TO "Closing The ComPort And Cleaning Up" CENTERED

   SWCCtrlDTR(PortId,0)                          // Drop DTR signal
   SWCSMEscap(PortId)                            // Get modem Command mode
   SWTWai(1000)
   SWCSMHoo(PortId,"0")                          // Hang Up the Phone
   SWTWai(1000)
   SWCCloseCo(PortId,0)                          // close da port


   // restore appropriate states
   CursorArro()
   oWnd:SetFocus()
   oBitMap3:End()
   oBtnQuit:Enable()
   oBtnDial:Enable()
   oItem1:Enable()
   oItem2:Enable()

   SET MESSAGE OF oWnd TO "Thank You For Trying FiveWin" CENTERED

RETURN NIL

STATIC FUNCTION ASilver()
   SWCDLGAbou( oWnd:hWnd )
RETURN NIL

STATIC FUNCTION AFiveWin()
   LOCAL oDlg

   DEFINE DIALOG oDlg RESOURCE "About"

   ACTIVATE DIALOG oDlg CENTERED

RETURN nil

Function DoBitMaps
   CursorWait()
   @ 3,5 BITMAP oBitMap1 RESOURCE "LOGIN" of oWnd
   @ 13,5 BITMAP oBitMap2 RESOURCE "DOWN" of oWnd
   @ 23,5 BITMAP oBitMap3 RESOURCE "BYE" of oWnd
   SWTWai(1000)                                  // give it a little time....
   oBitMap3:Hide()
   SWTWai(1000)                                  // give it a little time....
   oBitMap2:Hide()
   SWTWai(1000)                                  // give it a little time....
   oBitMap1:Hide()
   CursorArro()
RETURN NIL

// Modified Default MsgGet to Disable CANCEL Button
function MsgGet( cTitle, cText, uVar, cBmpFile )

   local oDlg
   local uTemp := uVar
   local lOk   := .f.

   DEFAULT cText := ""

   DEFINE DIALOG oDlg FROM 10, 20 TO 18, 59.5 TITLE cTitle

   @ 0.6, 4 SAY cText OF oDlg
   @ 1.6, 4 GET uTemp SIZE 120, 12 OF oDlg

   if ! Empty( cBmpFile )
      @ 1, 1 BITMAP FILENAME cBmpFile SIZE 20, 20 NO BORDER OF oDlg
   endif

   @ 3.5,  5 BUTTON "&Ok"  OF oDlg SIZE 35, 12 ;
      ACTION ( oDlg:End, lOk := .t. ) DEFAULT

   ACTIVATE DIALOG oDlg CENTERED

   if lOk
      uVar := uTemp
   endif

return lOk

//----------------------------------------------------------------------------//

